/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package webladenMitRDBMS;


import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Set;
import javax.swing.JOptionPane;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Marshaller;

/**
 *
 * @author micha
 */
public class DBZugriff {

    private java.sql.Connection dbVerbindung;
    private Statement sqlStatement;
    public ResultSet ergebnisTabelle;
    private PreparedStatement prepStmnt;

    public Connection getVerbindung() throws SQLException {
        //jdbc:postgresql://host:port/database
        return DriverManager.getConnection(
                "jdbc:postgresql://localhost:5432/webladen",
                "alfred",
                "mad"
        );
    }

    private webladenMitRDBMS.Produkt produkt;
    private String verzeichnis;
    //private Warenkorb warenkorb;
    private Produkt katalog;

    public DBZugriff(String datenbankname) {

        try {
            Class.forName("org.postgresql.Driver");
            dbVerbindung = DriverManager.getConnection(
                "jdbc:postgresql://localhost:5432/"+datenbankname,
                "alfred",
                "mad"
        );
        } catch (Exception e) {
            e.printStackTrace();
        }

//        this.verzeichnis = verzeichnis;
//        objF = new generated.ObjectFactory();
//        this.katalog = this.deSerializeKatalog();
    }

//    private generated.Produkt deSerializeKatalog() {
//        Produkt produkt = null;
//
//        try {
//            //unmarshaller erzeugen und xml nach objekt deserialisieren
//            JAXBContext context = JAXBContext.newInstance(Produkt.class);
//            Unmarshaller u = context.createUnmarshaller();
//
//            produkt = (Produkt) u.unmarshal(new File(verzeichnis + "/katalog.xml"));
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//
//        return produkt;
//    }

    public void serializeProdukt() {
        //marshaller erzeugen und serialisieren
        try {
            JOptionPane.showMessageDialog(null, "katalog wird gespeichert");
            // create JAXB context and instantiate marshaller

            JAXBContext context = JAXBContext.newInstance(Produkt.class);

            Marshaller m = context.createMarshaller();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

            // Write to System.out
            System.out.println("so sieht die katalog xml-datei aus:");
            m.marshal(this.katalog, System.out);

            // Write to File
            m.marshal(this.katalog, new File(verzeichnis + "/katalog.xml"));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

//    public List<generated.Produkt.Row> getGesamterKatalog() {
//        return katalog.getRow();
//    }

//    public void serializeWarenkorb(Warenkorb warenkorb) {
//        //marshaller erzeugen und serialisieren
//        try {
//            JOptionPane.showMessageDialog(null, "warenkorb wird gespeichert");
//            // create JAXB context and instantiate marshaller
//
//            JAXBContext context = JAXBContext.newInstance(generated.Warenkorb.class);
//
//            Marshaller m = context.createMarshaller();
//            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
//
//            // Write to System.out
//            System.out.println("so sieht die warenkorb xml-datei aus:");
//            m.marshal(warenkorb, System.out);
//
//            //JOptionPane.showMessageDialog(null, verzeichnis + "/warenkorb.xml");
//            // Write to File
//            m.marshal(warenkorb, new File(verzeichnis + "/warenkorb.xml"));
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

    ArrayList<String> getHerstellerListe() throws SQLException {

        //erzeugt abfrage auf datenbank, die alle herstellernamen 
        //liefert und speichert diese in einer ArrayList
        ArrayList<String> herstellerListe = new ArrayList();

        //preparedStatement fuer suche aller hersteller bauen
        prepStmnt = this.dbVerbindung.prepareStatement(
                "select hersteller from produkt"
        );

        //prepStmnt.setInt(1, id);
        this.ergebnisTabelle = prepStmnt.executeQuery();

        while (this.ergebnisTabelle.next()) {
            herstellerListe.add(this.ergebnisTabelle.getString("hersteller"));
        }

        return herstellerListe;

    }

    ArrayList<webladenMitRDBMS.Produkt> getProduktListe(String hersteller) throws Exception {

        ArrayList<webladenMitRDBMS.Produkt> produktListe = new ArrayList();

        //preparedStatement fuer suche aller hersteller bauen
        prepStmnt = this.dbVerbindung.prepareStatement(
                "select * from produkt where hersteller ilike ?"
        );

        prepStmnt.setString(1, hersteller+"%");
        this.ergebnisTabelle = prepStmnt.executeQuery();

        while(this.ergebnisTabelle.next()){
            webladenMitRDBMS.Produkt produkt = new webladenMitRDBMS.Produkt();
            produkt.setArt_nr(this.ergebnisTabelle.getString("art_nr"));
            produkt.setProduktname(this.ergebnisTabelle.getString("produktname"));
            produkt.setBeschreibung(this.ergebnisTabelle.getString("beschreibung"));
            produkt.setHersteller(this.ergebnisTabelle.getString("hersteller"));
            produkt.setPreis(this.ergebnisTabelle.getInt("preis"));
            
            produkt.setImg_name(this.ergebnisTabelle.getString("img_name"));
            produkt.setImg_pfad(this.ergebnisTabelle.getString("img_pfad"));
            produkt.setBestand(this.ergebnisTabelle.getInt("bestand"));
        produktListe.add(produkt);
                
        }
        
//        for (generated.Produkt.Row zeile : this.katalog.getRow()) {
//            if (zeile.getHersteller().equals(hersteller) || hersteller.equals("%")) {
//                this.produkt = new webladenMitRDBMS.Produkt();
//                this.setAttrsProdukt(zeile);
//                produktListe.add(produkt);
//            }
//        }
        return produktListe;
    }

//    public void updateBestand(String artNr, int abgang) {
//        for (generated.Produkt.Row zeile : this.katalog.getRow()) {
//            if (zeile.getArtNr().equals(artNr)) {
//                int bestand = zeile.getBestand();
//                bestand = bestand - abgang;
//                zeile.setBestand(bestand);
//            }
//        }
//    }

//    private void setAttrsProdukt(generated.Produkt.Row zeile) {
//        this.produkt.setArt_nr(zeile.getArtNr());
//        this.produkt.setProduktname(zeile.getProduktname());
//        this.produkt.setBeschreibung(zeile.getBeschreibung());
//        this.produkt.setHersteller(zeile.getHersteller());
//        this.produkt.setPreis(zeile.getPreis());
//        this.produkt.setImg_name(zeile.getImgName());
//        this.produkt.setImg_pfad(zeile.getImgPfad());
//        this.produkt.setBestand(zeile.getBestand());
//    }

    webladenMitRDBMS.Produkt getProdukt(String artNr) throws Exception {

//        for (generated.Produkt.Row zeile : this.katalog.getRow()) {
//            if (zeile.getArtNr().equals(artNr)) {
//                this.produkt = new webladenMitRDBMS.Produkt();
//                this.setAttrsProdukt(zeile);
//            }
//        }

        return produkt;
    }

//    public void erzeugeAuftrag(String nname, String vname, String adresse, HashMap<String, Position> warenkorb) {
//        this.warenkorb = new Warenkorb();
//
//        this.warenkorb.setName(nname);
//        this.warenkorb.setVname(vname);
//        this.warenkorb.setAdresse(adresse);
//
//        List positionen = this.warenkorb.getPosition();
//
//        //ueber die uebergebene HashMap mit den postitions-objekten iterieren
//        Set<String> keys = warenkorb.keySet();
//
//        for (String artNr : keys) {
//            Warenkorb.Position position = new Warenkorb.Position();
//            position.setArtNr(artNr);
//            position.setProduktname(warenkorb.get(artNr).getProdukt().getProduktname());
//            position.setStueckzahl(warenkorb.get(artNr).getAnzahl());
//            positionen.add(position);
//        }
//
//        this.serializeWarenkorb(this.warenkorb);
//    }

    public static void main(String[] args) {


    }

}
