drop database if exists webladen;
create database webladen;
drop role if exists alfred;
create user alfred with password 'mad';
\connect webladen


create table produkt(
   art_nr char(16), 
   produktname varchar(50), 
   beschreibung text, 
   hersteller varchar(50), 
   preis integer,
   img_name text, 
   img_pfad text,
   bestand integer
);

insert into produkt values('pro-lbx-ex6','Fishman Loudbox Artist','akusti-amp,fishman','fishman',64800,'lbx-ex6-front','loudbox.jpg',10);
insert into produkt values('quilter-tbl-200', 'Quilter Toneblock 200','Class-D, 200W-Minihead','Quilter Labs','39900','Quilter Tone Block 200','toneblock.png',4);
insert into produkt values('aer-ag-8', 'AER AG 8','AER 60W Active Monitor','AER','92400','AER AG 8','ag8Aer.jpg',2);

create table kunde(
   kundennr SERIAL,
   nname varchar(50),
   vname varchar(50),
   adresse varchar(200)
   );

create table bestellpos(
   pos SERIAL,
   artikel char(16),
   stueckzahl integer,
   kunde integer,
   datum date,
   best_nr integer
   );

grant all on produkt to alfred;
grant all on kunde to alfred;
grant all on bestellpos to alfred;
