<%-- 
    Document   : ergebnis
    Created on : 26.02.2015, 14:16:59
    Author     : dienert


<%@ page import="webladenMitRDBMS.Person" %>
--%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html>
    <fmt:setLocale value="de_DE"/>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0;" />

        <style>
            html {background:transparent!important
            }  
            body{
                margin: 10px auto;
                max-width: 60em;
                font-family: sans-serif;
                color: #333333;
            }

            h1, main{
                border-radius: 0px 0.5em 0.5em;
                border: 1px solid;
                padding: 2%;
                margin: 10px;
            }

            h1 {
                background: #F1F3F4  10px 5px no-repeat;
                border-color: #d5d5d5;
                padding-left:200px;
            }
            main {
                display: block;	
                background: #c4ced3;
                border-color: #8a9da8;
            }
            img {
                background: white;
                <%--border: 1px solid black;--%>
                width: 100%; 
                height: auto;	
            }
            rand { border: 1px solid black; }
            em {font-size: large}
            td {border: 1px solid black;}
        </style>

        <title>Hersteller und Produkte</title>
    </head>
    <body>

            <div style="text-align: center">
                <h2> Filtern Sie bei Bedarf nach einem Hersteller
                <table align="center">
                <tr>
                    <c:forEach items="${herstellerliste}" var="entry">
                        <td> <a href="Controller?action=FILTER_HERSTELLER&hersteller=${entry}">${entry}</a> </td>
                    </c:forEach>
                    <td>
                        <a href="Controller?action=FILTER_HERSTELLER&hersteller=%25">alle</a>
                    </td>
                </tr>
            </table>
            </div>
        </h2>

        <h1>Ihre zur Ansicht gewählten Artikel:</h1>

        <table>
            <c:forEach items="${produktliste}" var="entry">
                <tr>
                    <td>
                        <table>    
                            <tr><td>
                                    Art.Nr. <em>${entry.art_nr}</em>
                                </td></tr>
                            <tr><td><b>${entry.produktname}</b></td></tr>
                            <tr><td><b>
                                        <form method"POST"><table><tr>
                                                    <td><input name="anzahl" type="text"/></td>
                                                    <td><input value="In den Warenkorb" type="submit"/>
                                                        <input name="action" value="WARENKORB" type="hidden"/>
                                                        <input name="ARTNR" value="${entry.art_nr}" type="hidden"/>
                                                    </td>
                                                </tr></table></form>
                                    </b></td></tr>
                        </table>
                    </td>
                    <td>    
                        <img src="img/${entry.img_pfad}" 
                             title="${entry.img_name}"/>
                    </td>
                    <td>
                        ${entry.beschreibung}<br/>
                        Hersteller: ${entry.hersteller}<br/>
                        Verfügbar: ${entry.bestand}
                    </td>
                    <td>
                        <fmt:formatNumber value="${entry.preis/100}" 
                                          type="currency"/>
                    </td>

                </tr>
            </c:forEach> 
        </table>

        <a href="Controller?action=start">zur&uuml;ck zur Startseite</a>
        <a href="Controller?action=ende">abmelden</a>
    </body>
</html>
